Index: /code/branches/tutorial/data/levels/tutorial.oxw
===================================================================
--- /code/branches/tutorial/data/levels/tutorial.oxw	(revision 5765)
+++ /code/branches/tutorial/data/levels/tutorial.oxw	(revision 5766)
@@ -13,14 +13,4 @@
    skybox       = "Orxonox/skypanoramagen1"
   >
-
-<Drone name="meineDrohne" position="0,0,-10" primarythrust="80" auxilarythrust="10" rotationthrust="10" mass= "50" linearDamping = "0.9" angularDamping = "0.7">
-  <attached>
-    <Model scale="10" mesh="drone.mesh"/>
-  </attached>
-  <collisionShapes>
-    <BoxCollisionShape position="0,0,0"      halfExtents="10, 10, 10" />
-  </collisionShapes>
-</Drone>
-
 
     <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
Index: /code/branches/tutorial/src/orxonox/controllers/DroneController.cc
===================================================================
--- /code/branches/tutorial/src/orxonox/controllers/DroneController.cc	(revision 5765)
+++ /code/branches/tutorial/src/orxonox/controllers/DroneController.cc	(revision 5766)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Oli Scheuss
  *   Co-authors:
  *      ...
@@ -39,5 +39,6 @@
         // - make sure to register the object in the factory
         // - do any kind of initialisation
-        RegisterObject(DroneController);
+        
+        
         
         // this checks that our creator really is a drone
@@ -55,12 +56,10 @@
         // Place your code here:
         // - steering commands
-        static float totaltime = 0;
-        totaltime += dt;
         Drone *myDrone = static_cast<Drone*>(this->getControllableEntity());
-        if(totaltime<100)
-        {
-            myDrone->moveFrontBack( -sqrt(dt) );
-            myDrone->rotatePitch(-dt);
-        }
+        // you can use the following commands for steering
+        // - moveFrontBack, moveRightLeft, moveUpDown
+        // - rotatePitch, rotateYaw, rotateRoll
+        // - apply the to myDrone (e.g. myDrone->rotateYaw(..) )
+        
     }
 }
Index: /code/branches/tutorial/src/orxonox/controllers/DroneController.h
===================================================================
--- /code/branches/tutorial/src/orxonox/controllers/DroneController.h	(revision 5765)
+++ /code/branches/tutorial/src/orxonox/controllers/DroneController.h	(revision 5766)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Oli Scheuss
  *   Co-authors:
  *      ...
Index: /code/branches/tutorial/src/orxonox/worldentities/Drone.cc
===================================================================
--- /code/branches/tutorial/src/orxonox/worldentities/Drone.cc	(revision 5765)
+++ /code/branches/tutorial/src/orxonox/worldentities/Drone.cc	(revision 5766)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Oli Scheuss
  *   Co-authors:
  *      ...
@@ -34,5 +34,5 @@
 namespace orxonox
 {
-    // put your code in here:
+    // PLACE YOUR CODE HERE
     // create the factory for the drone
     CreateFactory(Drone);
@@ -40,9 +40,8 @@
     Drone::Drone(BaseObject* creator) : ControllableEntity(creator)
     {
-        //put your code in here:
+        this->myController_ = 0;
+        // PLACE YOUR CODE HERE
         // - register the drone class to the core
         // - create a new controller and pass our this pointer to it as creator
-        this->myController_ = 0;
-        RegisterObject(Drone);
         
         this->localLinearAcceleration_.setValue(0, 0, 0);
@@ -71,28 +70,27 @@
         SUPER(Drone, XMLPort, xmlelement, mode);
 
-        XMLPortParamVariable(Drone, "primaryThrust",  primaryThrust_,  xmlelement, mode);
-        XMLPortParamVariable(Drone, "auxilaryThrust", auxilaryThrust_, xmlelement, mode);
-        XMLPortParamVariable(Drone, "rotationThrust", rotationThrust_, xmlelement, mode);
+        // PLACE YOUR CODE HERE
+        // make sure you add the variables primaryThrust_, auxilaryThrust_ and rotationThrust_ to xmlport
+        // variables can be added by the following command
+        // XMLPortParamVariable(Class, "xml-attribute-name",  variable_name,  xmlelement, mode);
     }
 
     void Drone::tick(float dt)
     {
-        SUPER(Drone, tick, dt);
+        // PLACE YOUR CODE HERE
+        // make sure the tick function of the base class gets called here
         
-        //if (this->hasLocalController())
-        //{
-            this->localLinearAcceleration_.setX(this->localLinearAcceleration_.x() * getMass() * this->auxilaryThrust_);
-            this->localLinearAcceleration_.setY(this->localLinearAcceleration_.y() * getMass() * this->auxilaryThrust_);
-            if (this->localLinearAcceleration_.z() > 0)
-              this->localLinearAcceleration_.setZ(this->localLinearAcceleration_.z() * getMass() * this->auxilaryThrust_);
-            else
-              this->localLinearAcceleration_.setZ(this->localLinearAcceleration_.z() * getMass() * this->primaryThrust_);
-            this->physicalBody_->applyCentralForce(physicalBody_->getWorldTransform().getBasis() * this->localLinearAcceleration_);
-            this->localLinearAcceleration_.setValue(0, 0, 0);
-        
-            this->localAngularAcceleration_ *= this->getLocalInertia() * this->rotationThrust_;
-            this->physicalBody_->applyTorque(physicalBody_->getWorldTransform().getBasis() * this->localAngularAcceleration_);
-            this->localAngularAcceleration_.setValue(0, 0, 0);
-        //}
+        this->localLinearAcceleration_.setX(this->localLinearAcceleration_.x() * getMass() * this->auxilaryThrust_);
+        this->localLinearAcceleration_.setY(this->localLinearAcceleration_.y() * getMass() * this->auxilaryThrust_);
+        if (this->localLinearAcceleration_.z() > 0)
+          this->localLinearAcceleration_.setZ(this->localLinearAcceleration_.z() * getMass() * this->auxilaryThrust_);
+        else
+          this->localLinearAcceleration_.setZ(this->localLinearAcceleration_.z() * getMass() * this->primaryThrust_);
+        this->physicalBody_->applyCentralForce(physicalBody_->getWorldTransform().getBasis() * this->localLinearAcceleration_);
+        this->localLinearAcceleration_.setValue(0, 0, 0);
+    
+        this->localAngularAcceleration_ *= this->getLocalInertia() * this->rotationThrust_;
+        this->physicalBody_->applyTorque(physicalBody_->getWorldTransform().getBasis() * this->localAngularAcceleration_);
+        this->localAngularAcceleration_.setValue(0, 0, 0);
     }
     
Index: /code/branches/tutorial/src/orxonox/worldentities/Drone.h
===================================================================
--- /code/branches/tutorial/src/orxonox/worldentities/Drone.h	(revision 5765)
+++ /code/branches/tutorial/src/orxonox/worldentities/Drone.h	(revision 5766)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      Fabian 'x3n' Landau
+ *      Oli Scheuss
  *   Co-authors:
  *      ...