Index: code/trunk/src/libraries/util/CMakeLists.txt
===================================================================
--- code/trunk/src/libraries/util/CMakeLists.txt	(revision 5749)
+++ code/trunk/src/libraries/util/CMakeLists.txt	(revision 5774)
@@ -19,5 +19,4 @@
 
 SET_SOURCE_FILES(UTIL_SRC_FILES
-  Clipboard.cc
   CRC32.cc
   Exception.cc
Index: code/trunk/src/libraries/util/Clipboard.cc
===================================================================
--- code/trunk/src/libraries/util/Clipboard.cc	(revision 5749)
+++ 	(revision )
@@ -1,142 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Fabian 'x3n' Landau
- *   Co-authors:
- *      ...
- *
- *   Windows version inspired by "Copy Text To Clipboard" by Laszlo Szathmary, 2007
- *      http://www.loria.fr/~szathmar/off/projects/C/CopyTextToClipboard/index.php
- */
-
-/**
-    @file
-    @brief OS-specific implementations of the clipboard functions.
-*/
-
-#include "Clipboard.h"
-
-#ifdef ORXONOX_PLATFORM_WINDOWS
-
-/////////////
-// Windows //
-/////////////
-
-#ifndef WIN32_LEAN_AND_MEAN
-#  define WIN32_LEAN_AND_MEAN
-#endif
-#include <windows.h>
-#undef min
-#undef max
-#include "Debug.h"
-
-namespace orxonox
-{
-
-    /**
-        @brief Puts text into the windows-clipboard
-        @param text The text
-        @return True if the action was successful
-    */
-    bool toClipboard(const std::string& text)
-    {
-        try
-        {
-            if (OpenClipboard(0))
-            {
-                EmptyClipboard();
-                HGLOBAL clipbuffer = GlobalAlloc(GMEM_DDESHARE, text.size() + 1);
-                char* buffer = static_cast<char*>(GlobalLock(clipbuffer));
-                strcpy(buffer, text.c_str());
-                GlobalUnlock(clipbuffer);
-                SetClipboardData(CF_TEXT, clipbuffer);
-                CloseClipboard();
-
-                return true;
-            }
-        }
-        catch (...)
-        {
-            COUT(1) << "Error: Unable to copy the following text to the clipboard:" << std::endl;
-            COUT(1) << "       \"" << text << "\"" << std::endl;
-        }
-        return false;
-    }
-
-    /**
-        @brief Gets text from the windows-clipboard if there is any text.
-        @return The retrieved text
-    */
-    std::string fromClipboard()
-    {
-        try
-        {
-            if (OpenClipboard(0))
-            {
-                HANDLE hData = GetClipboardData(CF_TEXT);
-                std::string output = static_cast<char*>(GlobalLock(hData));
-                GlobalUnlock(hData);
-                CloseClipboard();
-
-                return output;
-            }
-        }
-        catch (...)
-        {
-            COUT(1) << "Error: Unable to retrieve text from the clipboard." << std::endl;
-        }
-        return "";
-    }
-}
-
-#else /* ORXONOX_PLATFORM_WINDOWS */
-
-/////////////
-// Default //
-/////////////
-
-namespace orxonox
-{
-    static std::string clipboard = ""; //!< Keeps the text of our internal clipboard
-
-    /**
-        @brief Default implementation if there is no OS-specific implementation or no clipboard. Copies the text into an internal clipboard.
-        @param text The text
-        @return True
-    */
-    bool toClipboard(const std::string& text)
-    {
-        clipboard = text;
-        return true;
-    }
-
-    /**
-        @brief Default implementation if there is no OS-specific implementation or no clipboard. Gets the text from the internal clipboard.
-        @return The text
-    */
-    std::string fromClipboard()
-    {
-        return clipboard;
-    }
-}
-
-#endif /* ORXONOX_PLATFORM_WINDOWS */
Index: code/trunk/src/libraries/util/Clipboard.h
===================================================================
--- code/trunk/src/libraries/util/Clipboard.h	(revision 5749)
+++ 	(revision )
@@ -1,54 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Fabian 'x3n' Landau
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-    @file
-    @brief Some functions to exchange text between the OS clipboard and Orxonox.
-
-    Use fromClipboard() to get text from the clipboard (if there is any text) and
-    toClipboard(text) to put text into the clipboard.
-
-    Those functions can only work properly if there's an OS-specific implementation.
-    If an OS isn't supported, the clipboard only works within Orxonox, but exchange
-    with other programs isn't possible.
-*/
-
-#ifndef _Clipboard_H__
-#define _Clipboard_H__
-
-#include "UtilPrereqs.h"
-#include <string>
-
-namespace orxonox
-{
-    _UtilExport bool toClipboard(const std::string& text);
-    _UtilExport std::string fromClipboard();
-}
-
-#endif /* _Clipboard_H__ */
-
Index: code/trunk/src/libraries/util/Exception.cc
===================================================================
--- code/trunk/src/libraries/util/Exception.cc	(revision 5749)
+++ code/trunk/src/libraries/util/Exception.cc	(revision 5774)
@@ -34,5 +34,4 @@
 
 #include "Exception.h"
-#include <CEGUIExceptions.h>
 
 namespace orxonox
@@ -106,13 +105,4 @@
             return ex.what();
         }
-        catch (const CEGUI::Exception& ex)
-        {
-#if CEGUI_VERSION_MAJOR == 0 && CEGUI_VERSION_MINOR < 6
-            return GeneralException(ex.getMessage().c_str()).getDescription();
-#else
-            return GeneralException(ex.getMessage().c_str(), ex.getLine(),
-                ex.getFileName().c_str(), ex.getName().c_str()).getDescription();
-#endif
-        }
         catch (...)
         {
Index: code/trunk/src/libraries/util/OgreForwardRefs.h
===================================================================
--- code/trunk/src/libraries/util/OgreForwardRefs.h	(revision 5749)
+++ 	(revision )
@@ -1,227 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-#ifndef _OgreForwardRefs_H__
-#define _OgreForwardRefs_H__
-
-#include "UtilPrereqs.h"
-
-namespace Ogre
-{
-    class Angle;
-    class Animation;
-    class AnimationState;
-    class AnimationStateSet;
-    class AnimationTrack;
-    class Archive;
-    class ArchiveFactory;
-    class ArchiveManager;
-    class AutoParamDataSource;
-    class AxisAlignedBox;
-    class AxisAlignedBoxSceneQuery;
-    class Billboard;
-    class BillboardChain;
-    class BillboardSet;
-    class Bone;
-    class Camera;
-    class Codec;
-    class ColourValue;
-    class ConfigDialog;
-    template <typename T> class Controller;
-    template <typename T> class ControllerFunction;
-    class ControllerManager;
-    template <typename T> class ControllerValue;
-    class Degree;
-    class DynLib;
-    class DynLibManager;
-    class EdgeData;
-    class EdgeListBuilder;
-    class Entity;
-    class ErrorDialog;
-    class ExternalTextureSourceManager;
-    class Factory;
-    class Font;
-    class FontPtr;
-    class FontManager;
-    struct FrameEvent;
-    class FrameListener;
-    class Frustum;
-    class GpuProgram;
-    class GpuProgramPtr;
-    class GpuProgramManager;
-	class GpuProgramUsage;
-    class HardwareIndexBuffer;
-    class HardwareOcclusionQuery;
-    class HardwareVertexBuffer;
-	class HardwarePixelBuffer;
-    class HardwarePixelBufferSharedPtr;
-	class HighLevelGpuProgram;
-    class HighLevelGpuProgramPtr;
-	class HighLevelGpuProgramManager;
-	class HighLevelGpuProgramFactory;
-    class IndexData;
-    class IntersectionSceneQuery;
-    class IntersectionSceneQueryListener;
-    class Image;
-    class KeyFrame;
-    class Light;
-    class Log;
-    class LogManager;
-	class ManualResourceLoader;
-	class ManualObject;
-    class Material;
-    class MaterialPtr;
-    class MaterialManager;
-    class MaterialScriptCompiler;
-    class Math;
-    class Matrix3;
-    class Matrix4;
-    class MemoryManager;
-    class Mesh;
-    class MeshPtr;
-    class MeshSerializer;
-    class MeshSerializerImpl;
-    class MeshManager;
-    class MovableObject;
-    class MovablePlane;
-    class Node;
-	class NodeAnimationTrack;
-	class NodeKeyFrame;
-	class NumericAnimationTrack;
-	class NumericKeyFrame;
-    class Overlay;
-    class OverlayContainer;
-    class OverlayElement;
-    class OverlayElementFactory;
-    class OverlayManager;
-    class Particle;
-    class ParticleAffector;
-    class ParticleAffectorFactory;
-    class ParticleEmitter;
-    class ParticleEmitterFactory;
-    class ParticleSystem;
-    class ParticleSystemManager;
-    class ParticleSystemRenderer;
-    class ParticleSystemRendererFactory;
-    class ParticleVisualData;
-    class Pass;
-    class PatchMesh;
-    class PixelBox;
-    class Plane;
-    class PlaneBoundedVolume;
-	class Plugin;
-    class Pose;
-    class ProgressiveMesh;
-    class Profile;
-	class Profiler;
-    class Quaternion;
-	class Radian;
-    class Ray;
-    class RaySceneQuery;
-    class RaySceneQueryListener;
-    class Renderable;
-    class RenderPriorityGroup;
-    class RenderQueue;
-    class RenderQueueGroup;
-	class RenderQueueInvocation;
-	class RenderQueueInvocationSequence;
-    class RenderQueueListener;
-    class RenderSystem;
-    class RenderSystemCapabilities;
-    class RenderTarget;
-    class RenderTargetListener;
-    class RenderTexture;
-	class MultiRenderTarget;
-    class RenderWindow;
-    class RenderOperation;
-    class Resource;
-	class ResourceBackgroundQueue;
-	class ResourceGroupManager;
-    class ResourceManager;
-    class RibbonTrail;
-	class Root;
-    class SceneManager;
-    class SceneManagerEnumerator;
-    class SceneNode;
-    class SceneQuery;
-    class SceneQueryListener;
-	class ScriptLoader;
-    class Serializer;
-    class ShadowCaster;
-    class ShadowRenderable;
-	class ShadowTextureManager;
-    class SimpleRenderable;
-    class SimpleSpline;
-    class Skeleton;
-    class SkeletonPtr;
-    class SkeletonInstance;
-    class SkeletonManager;
-    class Sphere;
-    class SphereSceneQuery;
-	class StaticGeometry;
-    class StringConverter;
-    class StringInterface;
-    class SubEntity;
-    class SubMesh;
-	class TagPoint;
-    class Technique;
-	class TempBlendedBufferInfo;
-	class ExternalTextureSource;
-    class TextureUnitState;
-    class Texture;
-    class TexturePtr;
-	class TextureFont;
-    class TextureManager;
-    class TransformKeyFrame;
-	class Timer;
-    class UserDefinedObject;
-    class Vector2;
-    class Vector3;
-    class Vector4;
-    class Viewport;
-	class VertexAnimationTrack;
-    class VertexBufferBinding;
-    class VertexData;
-    class VertexDeclaration;
-	class VertexMorphKeyFrame;
-    class WireBoundingBox;
-    class Compositor;
-    class CompositorManager;
-    class CompositorChain;
-    class CompositorInstance;
-    class CompositionTechnique;
-    class CompositionPass;
-    class CompositionTargetPass;
-
-    // Originally not in OgrePrerequisites.h
-    class BorderPanelOverlayElement;
-    class PanelOverlayElement;
-    class TextAreaOverlayElement;
-}
-
-#endif /* _OgreForwardRefs_H__ */
Index: code/trunk/src/libraries/util/UTFStringConversions.h
===================================================================
--- code/trunk/src/libraries/util/UTFStringConversions.h	(revision 5749)
+++ 	(revision )
@@ -1,61 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Fabian 'x3n' Landau
- *      Reto Grieder
- *   Co-authors:
- *      ...
- */
-
-/**
-@file
-@brief
-    std::sring to Ogre::UTFString conversion functions
-*/
-
-#ifndef _UTFStringConversions_H__
-#define _UTFStringConversions_H__
-
-#include "UtilPrereqs.h"
-#include <OgreUTFString.h>
-
-namespace orxonox
-{
-    template <>
-    struct ConverterExplicit<std::string, Ogre::UTFString>
-    {
-        //! Converts an std::string into an Ogre::UTFString
-        inline static bool convert(Ogre::UTFString* output, const std::string& input)
-        {
-            Ogre::UTFString::code_point cp;
-            for (unsigned int i = 0; i < input.size(); ++i)
-            {
-              cp = input[i];
-              cp &= 0xFF;
-              output->append(1, cp);
-            }
-            return true;
-        }
-    };
-}
-
-#endif /* _UTFStringConversions_H__ */